<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>LuckyDice</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-iYQeCzEYFbKjA/T2uDLTpkwGzCiq6soy8tYaI1GyVh/UjpbCx/TYkiZhlZB6+fzT" crossorigin="anonymous">
</head>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-u1OknCvxWvY5kfmNBILK2hRnQC3Pr17a+RTT6rIHI7NnikvbZlHgTPOOmMi466C8" crossorigin="anonymous"></script>
<style>
    .dicey-cover{
        background-image: url("LuckyDiceImages/cover.jpg");
        background-repeat: repeat-x;
        height: 100px
    }
</style>
<body >
    <div class="jumbotron">
        <header class="dicey-cover"></header>

            <div class="row m-2">
                <div class="col-sm-4 pl-3">
                    <h2 class="mt-3 mb-3">Thông tin cá nhân</h2>
                    <div class="row mb-3">
                        <label class="col-sm-3" for="inp-username">Username</label>
                        <input class="col-sm-9" type="text" id="inp-username" value="ngado20">
                    </div>
                    <div class="row mb-3">
                        <label class="col-sm-3" for="inp-first-name">First Name</label>
                        <input class="col-sm-9" type="text" id="inp-first-name"  value="do">
                    </div>
                    <div class="row mb-3">
                        <label class="col-sm-3" for="inp-last-name">Last Name</label>
                        <input class="col-sm-9" type="text" id="inp-last-name"  value="nga">
                    </div>
                </div>

                <div class="col-sm-5 text-center pt-3">
                        <button type="button" onclick="onBtnNewDiceClick()" class="btn btn-success mb-3">New Dice</button>
                        <img id="img-dice" class="rounded mx-auto d-block" src="LuckyDiceImages/dice.png" width="20%">
                        <p id="p-game-message" class="mt-3">Hãy đổ xúc xắc</p>
                </div>

                <div class="col-sm-2 text-center pt-3">
                    <p id="p-voucher"></p>
                    <img id="img-prize" class="rounded mx-auto d-block" src="" width="100%">
                </div>

            </div>

            <div class="d-flex justify-content-center">
                <input onclick="onBtnDiceHistoryClick()" type="radio" class="btn-check" name="group-display-table" id="btn-dice-history" autocomplete="off">
                <label class="btn btn-outline-success m-3" for="btn-dice-history">Dice History</label>

                <input onclick="onBtnVoucherHistoryClick()" type="radio" class="btn-check" name="group-display-table" id="btn-voucher-history" autocomplete="off">
                <label class="btn btn-outline-success m-3" for="btn-voucher-history">Voucher History</label>

                <input onclick="onBtnPrizeHistoryClick()" type="radio" class="btn-check" name="group-display-table" id="btn-present-history" autocomplete="off">
                <label class="btn btn-outline-success m-3" for="btn-present-history">Prize History</label>
            </div>

            <table id="table-data" class="table table-striped">
                <thead>
                  <tr>
                    <th scope="col">Lượt</th>
                    <th scope="col">Dice Value</th>
                  </tr>
                </thead>
                <tbody id="table-body-data">
                </tbody>
              </table>
    </div>
    
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        //base url
        const gBASE_URL = ""
        const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;  
        // data to be sent by post method
        var gUserData = {
            firstname: "",
            lastname: "",
            username: ""
        }
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // xử lý bấm nút new dice
    function onBtnNewDiceClick() {
        console.log("Nút new dice được ấn");
        // 01) đọc dữ liệu và lưu vào một đối tượng
        getUserData(gUserData);
        // 02) kiểm tra dữ liệu. Nếu hợp lệ thì thực hiện bước 03 và 04
        if (isUserDataValid(gUserData)) {
            // 03) gọi server, api (gửi yêu cầu request tới server)
            serverRequestNewDice(gUserData);
        }
    }

    function onBtnVoucherHistoryClick (){
        console.log("Nút voucher history được ấn");
        // 01) đọc dữ liệu và lưu vào một đối tượng
        getUserData(gUserData);
        // 02) kiểm tra dữ liệu. Nếu hợp lệ thì thực hiện bước 03 và 04
        if (isUserDataValid(gUserData)) {
            // 03) gọi server, api (gửi yêu cầu request tới server)
            serverRequestVoucherHistory(gUserData);
        }
    }
    function onBtnPrizeHistoryClick (){
        console.log("Nút prize history được ấn");
        // 01) đọc dữ liệu và lưu vào một đối tượng
        getUserData(gUserData);
        // 02) kiểm tra dữ liệu. Nếu hợp lệ thì thực hiện bước 03 và 04
        if (isUserDataValid(gUserData)) {
            // 03) gọi server, api (gửi yêu cầu request tới server)
            serverRequestPrizeHistory(gUserData);
        }
    }

    // xử lý bấm nút dice history
    function onBtnDiceHistoryClick() {
        console.log("Nút dice history được ấn");
        // 01) đọc dữ liệu và lưu vào một đối tượng
        getUserData(gUserData);
        // 02) kiểm tra dữ liệu. Nếu hợp lệ thì thực hiện bước 03 và 04
        if (isUserDataValid(gUserData)) {
            // 03) gọi server, api (gửi yêu cầu request tới server)
            serverRequestDiceHistory(gUserData);
        }
    }
    /*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function randomIntFromRange(min, max) { // min and max included 
        return Math.floor(Math.random() * (max - min + 1) + min)
    }

    function getUserData(paramUserData) {
        paramUserData.firstname = $("#inp-first-name").val().trim();
        paramUserData.lastname  = $("#inp-last-name").val().trim();
        paramUserData.username  = $("#inp-username").val().trim();
    }

    function isUserDataValid(paramUserData) {
        var isValid = paramUserData.username != "" &&
                      paramUserData.firstname != "" &&
                      paramUserData.lastname != "";
        return isValid;
    }

    function serverRequestDiceHistory(paramUserData) {

        var vUsername = paramUserData.username;
        // create a request
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        vXmlHttpDiceHistory.open("GET", gBASE_URL + "/devcamp-lucky-dice/dice-history?username=" + vUsername, true);
        vXmlHttpDiceHistory.send();

        vXmlHttpDiceHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log("Server Request Dice History OK!");
                    // parsing to object
                    var vResponse = JSON.parse(vXmlHttpDiceHistory.responseText);
                    console.log(vResponse)
                    // 04) xử lý dữ liệu front-end, hiển thị khi server phản hồi về
                    // load data into table
                    loadDiceHistoryTable(vResponse);
                }
            }
    }

    function loadDiceHistoryTable(paramResponse) {
        var vDiceHistory = paramResponse.diceHistory;
        var vShortDicesHistory = vDiceHistory.slice(-20);

        var vTableBody = $("#table-body-data");
        // clean table.
        vTableBody.html("")
        // điền lịch sử dice (ngắn) vào table
        for (var vIndex = 0; vIndex < vShortDicesHistory.length; vIndex++){
            var vNewRow = $("<tr/>").appendTo(vTableBody);
            var vNewTurn = $("<td/>").appendTo(vNewRow);
            var vNewValue = $("<td/>").appendTo(vNewRow);

            vNewTurn.html(vDiceHistory.length - vIndex);
            vNewValue.html(vShortDicesHistory[vShortDicesHistory.length-1-vIndex].dice);
        }
    }

    function serverRequestNewDice(paramUserData) {
        // create a request
        var vXmlHttpDice = new XMLHttpRequest();
        vXmlHttpDice.open("POST", gBASE_URL + "/devcamp-lucky-dice/dice", true);
        vXmlHttpDice.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        vXmlHttpDice.send(JSON.stringify(paramUserData));  //chuyển Json object sang string

        vXmlHttpDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                console.log("Server Request New Dice OK!");
                // parsing to object
                var vResponse = JSON.parse(vXmlHttpDice.responseText);
                // 04) xử lý dữ liệu front-end, hiển thị khi server phản hồi về
                // get result dice
                displayData(vResponse);
            }
        }
    }

    function displayData(paramResponse) {

        var vNewDice = paramResponse.dice;
        console.log("Xúc xắc : " + vNewDice);
        var vPlayerWon = vNewDice > 3;
        var vPVoucher = $("#p-voucher");
        var vImgPrize = $("#img-prize");

        // hiển thị hình ảnh xúc xắc
        var vImgDice = $("#img-dice");
        var vNewDiceSrc = "LuckyDiceImages/" + vNewDice + ".png";
        vImgDice.prop("src", vNewDiceSrc);

        // hiển thị game message
        var vPGameMessage = document.querySelector("#p-game-message");
        vPGameMessage.innerHTML = vPlayerWon ? "Chúc mừng" : "Chúc may mắn lần sau";

    // hiển thị voucher và prize

        // reset lại hiển thị phần thưởng cho lần chơi này
        vPVoucher.html("");
        vImgPrize.prop("src", "LuckyDiceImages/no-present.jpg");


        // nếu người chơi thắng thì hiển thị phần thưởng
        if (vPlayerWon){
            vImgPrize.prop("src", "");
            var hasVoucher = paramResponse.voucher != null;
            if (hasVoucher == true) {
                var vVoucher = paramResponse.voucher;
                vPVoucher.html  ("Voucher #" + vVoucher.code + ": " +
                                vVoucher.discount + "% chiết khấu");
                vPGameMessage.append (". Bạn nhận được một voucher!");
            }
            var hasPrize = paramResponse.prize != null;
            if (hasPrize == true) {
                var vPrize = paramResponse.prize;
                var vNewPrizeSrc = "LuckyDiceImages/" + vPrize.name + ".png";
                vImgPrize.prop("src", vNewPrizeSrc);
                vPGameMessage.append (" Bạn nhận được một giải thưởng đặc biệt!");
            }
        }
    }
</script>
</html>